#ifdef HEADER
void wm_test1_test(void);
#endif
#ifdef HANDLER
{"map_response", wm_test1_test},
#endif
#ifdef CODE
void
wm_test1_test(void)
{
   int i;
   double min_response = 99999999.0;
   double max_response = 0.0;
   double total_response = 0.0;
   
   for (i = 0; i < 1000; i++)
     {
	Window win;
	XSetWindowAttributes attr;
	XEvent ev;
	double t1, t2;
	
	attr.event_mask = ExposureMask;
	win = XCreateWindow(d, DefaultRootWindow(d), 0, 0, 200, 200, 0, 
			    DefaultDepth(d, DefaultScreen(d)),
			    InputOutput, 
			    DefaultVisual(d, DefaultScreen(d)),
			    CWEventMask,
			    &attr);
	XMapWindow(d, win);
	t1 = get_time();
	for (;;)
	  {
	     XNextEvent(d, &ev);
	     if (ev.type == Expose)
	       {
		  if (ev.xexpose.window == win)
		    {
		       t2 = get_time();
		       XDestroyWindow(d, win);
		       XSync(d, False);
		       t2 -= t1;
		       if (t2 > max_response) max_response = t2;
		       if (t2 < min_response) min_response = t2;
		       total_response += t2;
		       break;
		    }
	       }
	  }
     }
   total_response /= (double)i;
   snprintf(result, sizeof(result), 
	    "MIN: %3.6fs, MAX: %3.6f, AVG: %3.6f\n",
	    min_response, max_response, total_response);
}
#endif
